/*
 * Digitale Dörfer Plattform
 * Copyright (C) Fraunhofer IESE 2015 - 2022 Axel Wickenkamp, Balthasar Weitzel
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhg.iese.dd.platform.datamanagement.communication.repos;

import java.util.List;
import java.util.Set;

import org.springframework.data.jpa.repository.EntityGraph;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import de.fhg.iese.dd.platform.datamanagement.communication.model.Chat;
import de.fhg.iese.dd.platform.datamanagement.communication.repos.results.ChatCountByGeoAreaId;
import de.fhg.iese.dd.platform.datamanagement.participants.person.model.Person;

@Transactional(readOnly = true)
public interface ChatRepository extends JpaRepository<Chat, String> {

    /**
     * Find all chats with that topic and the given subject
     */
    @Query("select c "
            + "from Chat c "
            + "where c.topic = :topic "
            + "and exists (select 1 from ChatSubject cs "
            + "where cs.chat = c "
            + "and cs.entityName = :subjectEntityName "
            + "and cs.entityId = :subjectEntityId) "
            + "order by c.created desc ")
    List<Chat> findByTopicAndSubjectEntityOrderByCreatedDesc(
            String topic,
            String subjectEntityName,
            String subjectEntityId);

    /**
     * Find all chats with that subject
     */
    @Query("select c "
            + "from Chat c "
            + "where exists (select 1 from ChatSubject cs "
            + "where cs.chat = c "
            + "and cs.entityName = :subjectEntityName "
            + "and cs.entityId = :subjectEntityId) "
            + "order by c.created desc ")
    List<Chat> findBySubjectEntityOrderByCreatedDesc(
            String subjectEntityName,
            String subjectEntityId);

    /**
     * Get all chats with the topic and the person in the participants.
     *
     * @param topics the topics that need to be set for the chat
     * @param person the person that need to be in the set of participants of the chat
     */
    @Query("select c " +
            "from Chat c " +
            "join c.participants cp " +
            "join c.participants cpAll " +
            "where c.topic in :topics " +
            "and cp.person = :person " +
            "order by c.created desc")
    @EntityGraph(type = EntityGraph.EntityGraphType.LOAD,
            attributePaths = {"participants.person",
                    "participants.person.firstName",
                    "participants.person.lastName",
                    "participants.person.profilePicture",
                    "subjects",
                    "lastMessageNotAutoGenerated",
                    "lastMessageNotAutoGenerated.sender"})
    List<Chat> findByTopicsAndParticipantsOrderByCreatedDesc(
            Set<String> topics,
            Person person);

    @Query("select c " +
            "from ChatParticipant cp " +
            "join cp.chat c " +
            "where c.topic = :topic " +
            "and cp.person = :person " +
            "order by c.created desc")
    List<Chat> findByTopicAndParticipantsOrderByCreatedDesc(
            String topic,
            Person person);

    /**
     * Get the chat with that topic and exactly these participants.
     *
     * @param topic            the topic of the chat
     * @param participants     the persons that need to be exactly the participants of the chat
     * @param participantsSize size of the parameter participants. Unfortunately HQL/JPQL does not support the size
     *                         operation for parameters.
     */
    @Query("select c " +
            "from Chat c " +
            "where c.topic = :topic " +
            "and size(c.participants) = :participantsSize " +
            "and not exists (" +
            "select 1 " +
            "from c.participants p " +
            "where p.person not in :participants) " +
            "order by c.created desc ")
    List<Chat> findByTopicAndParticipantsOrderByCreatedDesc(
            String topic,
            Set<Person> participants,
            int participantsSize);

    /**
     * Get all chats the person is in the participants.
     *
     * @param person the persons that need to be in the set of participants of the chat
     */
    @Query("select c " +
            "from ChatParticipant cp " +
            "join cp.chat c " +
            "where cp.person = :person " +
            "order by c.created desc")
    List<Chat> findByParticipantsContainingOrderByCreatedDesc(
            Person person);

    /**
     * Get the number of chats per geo area
     *
     * @param lastCreated the creation date of the chat
     */
    @Query("select new de.fhg.iese.dd.platform.datamanagement.communication.repos.results.ChatCountByGeoAreaId(" +
            "cp.person.homeArea.id, " +
            "count(distinct cp.chat)) " +
            "from ChatParticipant cp " +
            "where cp.chat.created >= :lastCreated " +
            "group by cp.person.homeArea ")
    List<ChatCountByGeoAreaId> countByGeoAreaId(long lastCreated);

    /**
     * Get the number of active chats per geo area
     *
     * @param lastMessageCreated the creation date of the last not autogenerated message
     */
    @Query("select new de.fhg.iese.dd.platform.datamanagement.communication.repos.results.ChatCountByGeoAreaId(" +
            "cp.person.homeArea.id, " +
            "count(distinct cp.chat)) " +
            "from ChatParticipant cp " +
            "where cp.chat.lastMessageNotAutoGenerated.created >= :lastMessageCreated " +
            "group by cp.person.homeArea ")
    List<ChatCountByGeoAreaId> countActiveChatsByGeoAreaId(long lastMessageCreated);

}
